#DEFINE WIN32_LEAN_AND_MEAN
#DEFINE LINKFILES
#include <windows.h>
#include <commctrl.h>
#include <commdlg.h> ;include this or this wil fail -> mov d[ofn.Flags],OFN_LONGNAMES + OFN_EXPLORER + OFN_HIDEREADONLY 
//WS_OVERLAPPEDWINDOW	EQU	000CF0000h
//IDC_ARROW			EQU	07f00h
//CS_VREDRAW			EQU	00001h
//#define CS_HREDRAW  0x0002
//#define CS_CLASSDC  0x0040
//#define WM_CREATE   0x0001
//#Define WM_DESTROY  00002H
//#Define COLOR_WINDOW            	5

#define GetModuleHandle 	GetModuleHandleA
#define RegisterClassEx  	RegisterClassExA
#define CreateWindowEx		CreateWindowExA
#define GetMessage			GetMessageA
#define DispatchMessage		DispatchMessageA
#define UnregisterClass		UnregisterClassA
#define LoadCursor			LoadCursorA
#define DefWindowProc		DefWindowProcA
#define LoadIcon  			LoadIconA

#DEFINE GetModuleHandleExA GetModuleHandleExA_NotAvailable

ID_DOGIM equ 6000
;------------------------------------------------------------------
;
;      helloworld2 - copyright jeremy gordon 2002
;
;      simple "hello world" windows gdi program - for goasm
;
;      assemble using goasm helloworld2 (produces pe coff file)
;      then link using:-
;      golink helloworld2.obj user32.dll kernel32.dll gdi32.dll
;      (add -debug coff if you want to watch the program in the debugger)
;
;------------------------------------------------------------------
;

;
const section
messages DD WM_CREATE,    ON_CREATE       ;the message then the code address
         DD WM_DESTROY,  ON_DESTROY
        T

data section
szTitle			db	'hdtemplate version 1.0',0
hInstance 		dd 0            ;to keep the handle to the process itself
hdc   			dd 0            ;to keep the handle of the device context
paintstruct 	dd 16 dup 0  	;structure to hold stuff from windows on WM_PAINT
msg 			dd 7 dup 0        ;structure to hold messages from windows as follows:-
hWnd			dd ?
;hwnd, +4=message, +8=wparam, +c=lparam, +10h=time, +14h/18=pt
wc WNDCLASSEX
				;	+0	cbSize;
  				;	+4 	style;
  				;	+8 	lpfnWndProc;
  				;	+0C	cbClsExtra;
  				;	+10	cbWndExtra;
  				;	+14	hInstance;
  				;	+18	hIcon;
  				;	+1C	hCursor;
  				;	+20	hbrBackground;
  				;	+24	lpszMenuName;
  				;	+28 lpszClassName;
  				;	+2C	hIconSm;

Windows_ClassName db 'wc',0            		;string to hold name of window class


code section

Start:
	invoke	GetModuleHandle,0
	mov	[hInstance],eax         						;record it in data label hInstance
	invoke	InitCommonControls
; Prepare for RegisterclasEx API, by init WNDCLASSEX structure
	mov ebx,addr wc
	mov eax,(sizeof wc/4-1)								; counting begins at zero
init_loop:
	mov D[ebx+eax*4],0      							;fill it with zeroes
	dec eax
	jns init_loop
	mov	d[ebx],sizeof WNDCLASSEX						;cbsize
	mov eax,[hInstance]         						;get handle to the process
	mov [ebx+14h],eax       							;make it the window class
	invoke	LoadCursor,0,IDC_ARROW
	mov [ebx+1ch],eax       							;and give to WNDCLASS
	mov D[ebx+20h],6D       							;set background brush to COLOR_WINDOW+1
	invoke	LoadIcon,[ebx+014h],6000
	mov	d[ebx+018h],eax
	mov	d[ebx+02ch],eax									;hIconSm
	mov d[ebx+4h],CS_VREDRAW+CS_HREDRAW+CS_CLASSDC   	;cs_vredraw+cs_hredraw+cs_classdc (window class style)
	mov d[ebx+8h],addr WndProc          				;window procedure
	mov d[ebx+28h],addr Windows_ClassName    			;44d=2Chwindow class name
	push ebx                							;address of structure with window class data
	call RegisterClassEx			     				;register the window class

	
	push 0,[hInstance],0,0      						;lpParam hInstance hMenu hWndParent,
	push 200d,320d            							;height ,width
	push 50d,50d            							;position y then x
	push WS_OVERLAPPEDWINDOW+WS_VISIBLE					;window style
	push addr	szTitle						       		;window title
	push addr Windows_ClassName     					;window class name
	push 0                  							;extended window style
	call CreateWindowEx    								;make window, returning handle in eax
	mov	[hWnd],eax

	
Message_Loop:
	invoke	GetMessage,addr msg,0,0,0
	or eax,eax              							;see if it is wm_quit
	jz >End_Message            							;yes
	invoke	TranslateMessage,addr msg
	invoke	DispatchMessage,addr msg
	jmp < Message_Loop         							;after message dealt with, loop back for next one
End_Message:
	invoke	UnregisterClass,addr Windows_ClassName
	invoke	ExitProcess,[msg+08h]

	
WndProcTable:
	mov edx,addr messages   							;give edx the list of messages to deal with
	call WndProc		    							;call the generic message handler
	ret 10h                 							;restore the stack as required by caller


WndProc:
	FRAME hWnd,uMsg,wParam,lParam     					;establish stack frame and get parameters
	uses	esi, edi, ebp
	mov eax,[uMsg]          							;get in eax message sent by Windows
	mov ecx,sizeof messages/8         					;get number of messages to look at
	mov edx,addr messages
L2:
	dec ecx
	js >.notfound
	//int 3
	cmp [edx+ecx*8],eax     							;see if its the correct message
	jnz L2                  							;no
	call [edx+ecx*8+4]      							;call the correct procedure for the message
	jnc >.exit
.notfound
	invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
.exit
	ret
ENDF                    								;finish this satck frame



ON_CREATE:                 								;one of the few messages dealt with by this prog
	xor eax,eax             							;return zero to make window
	ret

ON_DESTROY:                								;one of the few messages dealt with by this prog
	invoke	PostQuitMessage,0
	stc                     							;go to defwindowproc too
	ret

